Changes to bldpkg:

* Discard empty install directory but return true if it fails
* Code to verify sha512 checksums is now housed inside an if/else
* Renamed filename used for testing parenttmp and tmpfs directories
* Added [INFO] to printf in the compressor validation line
* Added ampersand when validating sccached
* Discarded if/else code for checking autobuildtemp variable
* Reordered code so compiler validation only occurs after mkandenterbuilddir is executed
This commit is contained in:
PktSurf 2023-05-03 17:04:52 +05:30
parent 4e6156c974
commit f1f548ecd6

207
bldpkg
View file

@ -3,7 +3,7 @@
# Part of the SMLinux distribution
# http://git.pktsurf.in/smlinux
#
# /bin/bldpkg version 0.100
# /bin/bldpkg version 0.101
# Bash script to build SMLinux-specific packages
#
# Copyright (c) 2022-2023 PktSurf <smlinux@pktsurf.in>
@ -253,7 +253,7 @@ EOF
# Error out if the outputs don't match
if [[ $finaloutput != $randomnum ]] ;then
err "Compiler validation failed!"
err " failed!"
else
rm "$parenttmp/$compileroutput"*
printf " done\n"
@ -614,8 +614,9 @@ EOF
# Discard charset.alias
[[ -f lib/charset.alias ]] && rm lib/charset.alias
# Also discard the lib directory if it's empty but don't error out
# Also discard the lib and install directory if it's empty but don't error out
rmdir lib &> /dev/null || true
rmdir install &> /dev/null || true
tar cvf - . --format gnu \
--xform 'sx^\./\(.\)x\1x' \
@ -869,7 +870,7 @@ EOF
promptuser
}
# Then source the configuration file holding all values
# Source the main configuration file holding all necessary values
if [[ -f $HOME/.bldpkg.conf ]] ; then
source "$HOME/.bldpkg.conf"
elif [[ -f /etc/bldpkg.conf ]] ; then
@ -890,13 +891,6 @@ srcdir="$PWD"
# unless otherwise overridden using -f <buildfile>
buildfile="${srcdir##*/}.SMBuild"
# Run a for loop to find compile and build-related files
for requiredfile in "${rqfiles[@]}"; do
if [[ ! -x $(type -p "$requiredfile") ]] ; then
err "Could not find required program '$requiredfile'!"
fi
done
# While loop for providing handy arguments to users. Some will override bldpkg.conf.
while getopts ':def:ghj:o:rstvx' option; do
case "$option" in
@ -917,9 +911,9 @@ while getopts ':def:ghj:o:rstvx' option; do
esac
done
# The getopts builtin sets the OPTIND environment variable whose value is set to 1 if no argument
# is given. For every argument passed, the number is incremented by 1. In our case, if OPTIND equals
# 1, no argument was passed. We therefore expect a package build file to be present which will be then sourced.
# The getopts builtin sets the OPTIND environment variable whose value is set to 1 if no argument is given.
# For every argument passed, the number is incremented by 1. In our case, if OPTIND equals 1, no argument
# was passed. We therefore expect a package build file to be present which will then be validated and sourced.
if [[ $OPTIND = 1 ]] ; then
if [[ ! -f $buildfile ]] ; then
nopackagebuildfileerror
@ -993,48 +987,24 @@ unset OPTIND OPTARG
# Display the package and its version we are building or resuming
if [[ -z $resumepkgbuild ]] ; then
info "Building package '$app' version '$version' ..."
sleep 0.5
else
info "Resuming build of package '$app' version '$version' ..."
fi
# Check integrity of files defined in sha512sums variable which is expected
# in nearly every single package build file
[[ -z $sha512sums ]] && err "Please run 'bldpkg -g' to add sha512sums into '$buildfile'!"
eval sums=\"\$sha512sums\"
info "Verifying SHA512 checksums against source files..."
IFS=$'\n'
for src in $sums; do
if ! echo $src | sha512sum -c ; then
err "Checksums failed to match!"
fi
done
unset IFS
# Do a preliminary package dependency check if $checkdependencies is set to 1 in bldpkg.conf
if [[ $checkdependencies = 1 ]] ; then
info "Parsing $app 's dependency list..."
for packagedep in $requires; do
depcount=$(find /share/doc -type f -name "$packagedep.SMBuild" | wc -l)
# If count is 1, we are ok
if [[ $depcount = 1 ]] ; then
info "Found dependency '$packagedep'"
# If count is 0, we exit, because we are in trouble
elif [[ $depcount = 0 ]] ; then
err "Did not find dependency '$packagedep'"
# If count is greater than or equal to 2, we are in slightly less trouble
elif [[ $depcount -ge 2 ]] ; then
warn "Found multiple versions of '$packagedep' !"
sleep 0.5
if [[ -z $sha512sums ]] ; then
err "Please run 'bldpkg -g' to add sha512sums into '$buildfile'!"
else
eval sums=\"\$sha512sums\"
info "Verifying SHA512 checksums against source files..."
IFS=$'\n'
for src in $sums; do
if ! echo $src | sha512sum -c ; then
err "Checksums failed to match!"
fi
done
unset IFS
fi
# Check if $parenttmp is set and is a directory
@ -1046,11 +1016,11 @@ fi
# Attempt to write to the $parenttmp directory. This directory is used for everything related to the
# build process outside the source directory $srcdir
if ! touch "$parenttmp/.smlinuxwritetest" ; then
if ! touch "$parenttmp/.parenttmpwritetest" ; then
err "Parent temp directory '$parenttmp' is not writable!"
else
# Discard the test file
rm "$parenttmp/.smlinuxwritetest"
rm "$parenttmp/.parenttmpwritetest"
fi
# If htmloutput is set to 1, echo $app, $version and $build as file names inside the parent build directory.
@ -1071,7 +1041,7 @@ EOF
touch "$parenttmp/BUILDING"
fi
printf "Validating '$compressor' and its options..."
printf "[INFO] Validating compressor '$compressor'..."
mkdir -p "$parenttmp/.tar.testdir"
touch "$parenttmp/.tar.testdir/.tar.testfile"
@ -1085,16 +1055,16 @@ rm -r "$parenttmp/.tar.testdir"*
# Validate the TMPFS directory if usetmpfs is set to 1 and tmpfsdir variable is set. If it fails,
# declare a variable for the build summary.
if [[ $tmpfs = 1 ]] && [[ -n $tmpfsdir ]]; then
if [[ ! -d $tmpfsdir ]] || ! touch "$tmpfsdir/.smlinuxtmpwritetest" \
if [[ ! -d $tmpfsdir ]] || ! touch "$tmpfsdir/.tmpfswritetest" \
|| [[ $(findmnt -no TARGET $tmpfsdir) != $tmpfsdir ]] \
|| [[ $(findmnt -no FSTYPE $tmpfsdir) != tmpfs ]]; then
tmpfscheckfailed=1
fi
# Discard the file used to test the tmp directory
[[ -e "$tmpfsdir/.smlinuxtmpwritetest" ]] && rm "$tmpfsdir/.smlinuxtmpwritetest"
rm "$tmpfsdir/.tmpfswritetest"
# Check the tmpfsdir for stale directories from previous builds. If found, issue a warning.
# Check the tmpfsdir for stale directories from previous pkg builds. If found, issue a warning.
if [[ $(find "$tmpfsdir" -type d -maxdepth 1 -name "*.src" -o -name "package-*" | wc -l) -gt 0 ]]; then
if [[ ! -d $tmpfsdir/package-$app ]] || [[ ! -d $tmpfsdir/$app.src ]] ; then
warn "TMPFS directory '$tmpfsdir' has stale directories from previous builds!"
@ -1116,9 +1086,8 @@ if [[ $swapcheck = 1 ]]; then
fi
fi
# Set the build and package staging directories. This is where package
# files that get "installed" go into, for example 'make install DESTDIR=$pkg'
# or 'DESTDIR="$pkg" ninja install'.
# Set the build and package staging directories. This is where package files that get "installed" go into,
# for example 'make install DESTDIR=$pkg' or 'DESTDIR="$pkg" ninja install'.
# If tmpfs is set to 1 and tmpfscheckfailed variable is unset, determine
# if the $app is in the exception list and whether to build inside or outside the TMPFS directory.
@ -1172,19 +1141,66 @@ if inarray "${tmp}" "${protecteddirectories[@]}" ; then
err "'tmp' VARIABLE IS SET TO '$tmp' WHICH IS A PROTECTED DIRECTORY! EXITING!"
fi
# Define a temporary file for printing summary
tempfile=$(mktemp "$parenttmp/SMBUILD.XXXXXX")
# https://unix.stackexchange.com/questions/462392/bash-the-function-is-executed-twice
# https://stackoverflow.com/questions/9256644/identifying-received-signal-name-in-bash/9256709
# We use two traps to identify the signals, EXIT and INT.
trap "prepbuildoutput" EXIT
trap "interruptoutput" INT
# If $tmp exists, get the path to the $.app-$version.extraction.complete file
[[ -d $tmp ]] && buildresumepath="$(find $tmp -type f -name .$app-$version.extraction.complete)"
# If the above file exists, $resumepkgbuild and $autobuild are unset
# and $autoresumepkgbuild is set to 1 in bldpkg.conf, prompt the user
if [[ -f $buildresumepath ]] && [[ -z $resumepkgbuild ]] && [[ $autoresumepkgbuild = 1 ]] && [[ -z $autobuild ]]; then
read -r -p "[NOTIFY] Would you like to resume building? " yn
case "$yn" in
N|n|No|no) info "Nope? Alright." ;
unset resumepkgbuild ;;
*) info "Wise choice :-) "
resumepkgbuild=1 ;;
esac
fi
# If $resumepkgbuild variable is not set in getopts, only then execute prepbuilddir variable
[[ -z $resumepkgbuild ]] && prepbuilddir
# If $resumepkgbuild is set either in getopts or from the user prompt above, execute mkandenterbuilddir
# function to enter the build directory. This is being done because mkandenterbuilddir is part of prepbuilddir
# function in the build file and ignoring prepbuilddir will not cause mkandenterbuilddir to be invoked
# separately unless the build system is told to.
if [[ -n $resumepkgbuild ]] ; then
mkandenterbuilddir
# fixbuilddirpermissions places a file ".$app-$version.extraction.complete". Only resume the build if that file exists
if [[ ! -f $buildresumepath ]] ; then
err "Can't resume build of '"$app"'! Are you certain the source was extracted completely?"
else
cd ${buildresumepath%/*}
fi
fi
# Run a for loop to find compile and build-related files
for requiredfile in "${rqfiles[@]}"; do
if [[ ! -x $(type -p "$requiredfile") ]] ; then
err "Could not find required program '$requiredfile'!"
fi
done
# Apply CPU-specific compiler variables defined inside bldpkg.conf
# https://github.com/sakaki-/gentoo-on-rpi-64bit/blob/master/reference/compile_run_benchmarks.sh
# https://www.raspberrypi.org/forums/viewtopic.php?t=11629
# noarch is set inside initfs, pkgtools, GTK themes and some other stuff.
# If $arch has not been exported by autobuild or not set in the individual build files that have
# arch=noarch, we set our own. $HOSTTYPE is only set in the bash shell.
# Only set $arch if it's not set in the build file. We take the help of $HOSTTYPE variable set by the bash shell.
[[ -z $arch ]] && arch="$HOSTTYPE"
for compilervariable in CC CXX CFLAGS ; do
[[ -z $compilervariable ]] && err "$compilervariable not set in bldpkg.conf!"
done
# Clean out CFLAGS if $arch is set to noarch
if [[ $arch = noarch ]]; then
CFLAGS=""
elif [[ -n $debug ]]; then
@ -1211,8 +1227,7 @@ fi
# Validate everything related to sccache if ccache is set
if [[ $sccache = 1 ]]; then
[[ ! -x $sccachebinpath ]] & err "$sccachebinpath was either not found or is not an executable!"
[[ ! -x $sccachebinpath ]] && err "$sccachebinpath was either not found or is not an executable!"
# We expect the rustc wrapper to be defined in $HOME/.cargo/config.toml
if ! grep -q 'rustc-wrapper\ \= "\/bin\/sccache"' $HOME/.cargo/config.toml ; then
@ -1227,7 +1242,6 @@ rustc-wrapper = "/bin/sccache"'
export RUSTC_WRAPPER
sccacheprocess start
fi
# Validate everything related to distcc if distcc is set
@ -1280,56 +1294,25 @@ if [[ -z $noautoconfsite ]] ; then
fi
fi
# Condition to reuse the autobuildtemp file if set from autobuild or make a new temporary file
if [[ -n $autobuildtemp ]]; then
tempfile="$autobuildtemp"
else
tempfile=$(mktemp "$parenttmp/SMBUILD.XXXXXX")
# Do a preliminary package dependency check if $checkdependencies is set to 1 in bldpkg.conf
if [[ $checkdependencies = 1 ]] ; then
info "Parsing $app 's dependency list..."
for packagedep in $requires; do
depcount=$(find /share/doc -type f -name "$packagedep.SMBuild" | wc -l)
# If count is 1, we are ok
if [[ $depcount = 1 ]] ; then
info "Found dependency '$packagedep'"
# If count is 0, we exit, because we are in trouble
elif [[ $depcount = 0 ]] ; then
err "Did not find dependency '$packagedep'"
# If count is greater than or equal to 2, we are in slightly less trouble
elif [[ $depcount -ge 2 ]] ; then
warn "Found multiple versions of '$packagedep' !"
sleep 0.5
fi
done
fi
# https://unix.stackexchange.com/questions/462392/bash-the-function-is-executed-twice
# https://stackoverflow.com/questions/9256644/identifying-received-signal-name-in-bash/9256709
# We use two traps to identify the signals, EXIT and INT. EXIT will invoke 'prepbuildoutput' function on any exit
# status >= 0. The script fail status is determined by the above pkgstatus or any premature compile failure.
# The 'interruptoutput' function is invoked when the user sends CTRL-C aka SIGINT. The SIGINT trap does not work
# for auto builds, it has been added in the section build file too.
trap "prepbuildoutput" EXIT
trap "interruptoutput" INT
# If $tmp exists, get the path to the $.app-$version.extraction.complete file
[[ -d $tmp ]] && buildresumepath="$(find $tmp -type f -name .$app-$version.extraction.complete)"
# If the above file exists, $resumepkgbuild and $autobuild are unset
# and $autoresumepkgbuild is set to 1 in bldpkg.conf, prompt the user
if [[ -f $buildresumepath ]] && [[ -z $resumepkgbuild ]] && [[ $autoresumepkgbuild = 1 ]] && [[ -z $autobuild ]]; then
read -r -p "[NOTIFY] Would you like to resume building? " yn
case "$yn" in
N|n|No|no) info "Nope? Alright." ;
unset resumepkgbuild ;;
*) info "Wise choice :-) "
resumepkgbuild=1 ;;
esac
fi
# If $resumepkgbuild variable is not set in getopts, only then execute prepbuilddir variable
[[ -z $resumepkgbuild ]] && prepbuilddir
# If $resumepkgbuild is set either in getopts or from the user prompt above, execute mkandenterbuilddir
# function to enter the build directory. This is being done because mkandenterbuilddir is part of prepbuilddir
# function in the build file and ignoring prepbuilddir will not cause mkandenterbuilddir to be invoked
# separately unless the build system is told to.
if [[ -n $resumepkgbuild ]] ; then
mkandenterbuilddir
# fixbuilddirpermissions places a file ".$app-$version.extraction.complete". Get the directory name that houses that file
# and cd into it
if [[ ! -f $buildresumepath ]] ; then
err "Can't resume build of '"$app"'! Are you certain the source was extracted completely?"
else
cd ${buildresumepath%/*}
fi
fi
build
# End script